-- Lua ű
-- ӺУѭɵȴһ

local GRAPH_CMD = {0x4E, 0x00, 0x06, 0x00, 0x00, 0x01, 0x0A, 0x00, 0x00}


local FLAG_INIT = 0
--/* ڲʹ */
local   FlickerTime					= 100
local   Last_Time_Tick				= 0
local   Current_Time_Tick			= 0
local   UPGRADE_BAR_TIME_GAP_Count	= 0
local   UPGRADE_BAR_TIME_GAP		= 0


local 	 Curve_buff 				= {}
local   Curve_Pos				= 1
local   Curve_MAX_NUM			= 150

function Init()
	hmt.writevp16(0x080022,63)
	hmt.writevp16(0x080024,100)
	hmt.writevp16(0x080026,220)
	hmt.writevpstr(0x000100, "100%")

	hmt.writevp16(0x080004,10)
	hmt.writevp16(0x080006,30)
	hmt.writevp16(0x080008,75)
	hmt.writevp16(0x08000A,95)
	hmt.writevp16(0x08000C,55)
	hmt.writevp16(0x08000E,10)

	Curve_Pos = 1


	for i = 1, Curve_MAX_NUM do
		-- Ҳֵ
		local angle = math.rad((i / Curve_MAX_NUM) * 360)
		local value = 100 * math.sin(angle)
		-- ֵ뵽ݱ
		table.insert(Curve_buff, math.floor(value))
	end

end






--****************************************



function UpdateCurve()

	local nData  = 0x0000

	if( Curve_Pos >= Curve_MAX_NUM )then
		Curve_Pos = 1
	end

	nData 			= Curve_buff[Curve_Pos]
	if(nData ~= nil )then

		GRAPH_CMD[8] 	= (nData>>8)& 0XFF
		GRAPH_CMD[9] 	= nData &0xFF
		hmt.runcmd(GRAPH_CMD,#GRAPH_CMD)

		Curve_Pos = Curve_Pos + 1
	end

	hmt.writevpstr(0x000080,Curve_Pos.." => "..nData)
end




function valueToPercent(value)
    if value >= 0 or value <= 63 then
		return string.format("%.f%%", (value / 63) * 100)

    end
    return ""
end


function UpdateProgressBar()
	hmt.writevp16(0x080004,math.random(0, 100))
	hmt.writevp16(0x080006,math.random(0, 100))
	hmt.writevp16(0x080008,math.random(0, 100))
	hmt.writevp16(0x08000A,math.random(0, 100))
	hmt.writevp16(0x08000C,math.random(0, 100))
	hmt.writevp16(0x08000E,math.random(0, 100))
end

function  setBacklight(id)

	local curr_backlight = hmt.readvp16(0x080022)

	if(id == 20 ) then
		if( curr_backlight > 10 )then
			curr_backlight = curr_backlight - 1
			hmt.writevp16(0x080022, curr_backlight)
			hmt.writevpstr(0x000100, valueToPercent(curr_backlight))

			local cmd_set_bl = {0x5F,0x00}
			cmd_set_bl[2] =  curr_backlight & 0xFF
			hmt.runcmd(cmd_set_bl,#cmd_set_bl)

		end
	elseif( id == 21 )then
		if( curr_backlight < 63 )then
			curr_backlight = curr_backlight + 1
			hmt.writevp16(0x080022, curr_backlight)
			hmt.writevpstr(0x000100, valueToPercent(curr_backlight))

			local cmd_set_bl = {0x5F,0x00}
			cmd_set_bl[2] =  curr_backlight & 0xFF
			hmt.runcmd(cmd_set_bl,#cmd_set_bl)
		end
	end
end

-- ѭ 10ms
luamain = function (void)
	if( FLAG_INIT == 0) then
		FLAG_INIT = 1
		Init()
	end

	Current_Time_Tick = hmt.gettick()
    local tick_num = Current_Time_Tick - Last_Time_Tick
	if( tick_num >= FlickerTime )or(tick_num <= 0) then

		local curr_page = hmt.readpage()
		if(curr_page  == 2 )or(curr_page==6)then
			if(UPGRADE_BAR_TIME_GAP_Count == 6)then
				UpdateProgressBar()
				UPGRADE_BAR_TIME_GAP_Count = 0
			end
			UPGRADE_BAR_TIME_GAP_Count = UPGRADE_BAR_TIME_GAP_Count + 1


		end

		if(curr_page  == 0 )or(curr_page==4)then
			--local nData = math.random(-100, 100)
			--GRAPH_CMD[8] = (nData>>8)& 0XFF
			--GRAPH_CMD[9] = nData &0xFF
			--hmt.runcmd(GRAPH_CMD,#GRAPH_CMD)

			UpdateCurve()
			hmt.writevpstr(0x000180,#Curve_buff)
		end




		Last_Time_Tick = Current_Time_Tick
	end







end
---------------------------------------------------------------------

-- ¼Ӻ
tpkhook = function (page,id,state)

	-- set backlight
	if( page  == 3) or (page  == 7) and  (state == 0) then
		setBacklight(id)
	end

	-- set language
	if( page  == 8) and  (state == 0) then
		if( id == 0 )then
			hmt.writevp16(0x08001E, 0)
			hmt.changepage(3)
		elseif(id == 1 )then
			hmt.writevp16(0x08001E, 1)
			hmt.changepage(7)
		end
	end

	return 0
end
---------------------------------------------------------------------

-- ҳлʱӺ
pagechangehook = function (page)

	if(page  == 2 )or(page==6)then

		UpdateProgressBar()

	end

	return 0
end
---------------------------------------------------------------------

